#include <ESP8266WiFi.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"
#include "AdafruitIO_WiFi.h"
#include <BlynkSimpleEsp8266.h>

#define ESP_SSID "****"
#define ESP_PASS "***********"
char auth[] = "Ye2PiVZ89esPQ-py6gYhDmuzZbY2RtSr";
char ssid[] = ESP_SSID;
char pass[] = ESP_PASS;

#define BLYNK_PRINT Serial

int Speaker = 13; // GPIO13
WiFiServer server(80);
int c = 262;
int d = 294;
int e = 330;
int f = 349;
int g = 392;
int a = 440;
int b = 494;
int bf = 466;
int C = 523;
int frequency[56] = {
  c, d, f, d, a, a, g, c, d, f, d, g, g, f, e, d, c, d, f, d, f, g, e, d, c, c, g, f,
  c, d, f, d, a, a, g, c, d, f, d, C, e, f, e, d, c, d, f, d, f, g, e, d, c, c, g, f};
int duration1[56] = {
  120, 120, 120, 120, 360, 360, 720, 120, 120, 120, 120, 360, 360, 480, 120, 240, 120, 120, 120, 120,
  480, 240, 360, 120, 480, 240, 480, 960,
  120, 120, 120, 120, 360, 360, 720, 120, 120, 120, 120, 360, 360, 480, 120, 240, 120, 120, 120, 120,
  480, 240, 360, 120, 480, 240, 480, 960};

#define LED D0

#define WLAN_SSID "*****"
#define WLAN_PASS "**********"

#define AIO_SERVER "io.adafruit.com"
#define AIO_SERVERPORT 1883
#define AIO_USERNAME "****"
#define AIO_KEY "aio_LOsr380zMS0xHlfCWdECFzjhDRul"

#define echoPin D5 // Echo Pin
#define trigPin D6 // Trigger Pin

void connect();
WiFiClient client;

const int ledPin = 5;
const int ldrPin = A0;

const char MQTT_SERVER[] = AIO_SERVER;
const char MQTT_CLIENTID[] = AIO_KEY __DATE__ __TIME__;
const char MQTT_USERNAME[] = AIO_USERNAME;
const char MQTT_PASSWORD[] = AIO_KEY;
Adafruit_MQTT_Client mqtt(&client, MQTT_SERVER, AIO_SERVERPORT,
MQTT_CLIENTID, MQTT_USERNAME, MQTT_PASSWORD);

const char DISTANCE_FEED[] = AIO_USERNAME "/feeds/distance";
Adafruit_MQTT_Publish distance = Adafruit_MQTT_Publish(&mqtt,
DISTANCE_FEED);

int count = 0;
long duration, distance_data; // Duration used to calculate distance


void setup()
{
  Serial.begin (115200);
  Blynk.begin(auth, ssid, pass);

  pinMode(Speaker, OUTPUT);
  digitalWrite(Speaker, HIGH);

 pinMode(LED, OUTPUT);

  pinMode(ledPin, OUTPUT);  
  pinMode(ldrPin, INPUT);
    
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  
  WiFi.begin(WLAN_SSID, WLAN_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    delay(10);
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  Serial.println();
  connect();
  delay(1000);
}
 
void loop()
{
  // ping adafruit io a few times to make sure we remain connected
  if (! mqtt.ping(3)) {
  // reconnect to adafruit io
    if (! mqtt.connected())
      connect();
  }
  Blynk.run();

  int ldrStatus = analogRead(ldrPin);
   pinMode(LED, OUTPUT);
   Serial.println(ldrStatus);

  /* The following trigPin/echoPin cycle is used to determine the
  distance of the nearest object by bouncing soundwaves off of it. */
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  //Calculate the distance (in cm) based on the speed of sound.
  distance_data = duration/58.2;
  Serial.println(distance_data);
  
  if (distance_data < 5 || ldrStatus < 8 ){
     Blynk.notify("!!!");
     for(int i=0; i<56; i++){ //run loop for all values of i 0 to __ 
        tone(Speaker, frequency[i]); 
        delay(duration1[i]);  
        noTone(Speaker);   //turn off speaker for 30ms before looping back to the next note
       delay(10);
     }
    digitalWrite(LED, HIGH);
    delay(1000);
    digitalWrite(LED, LOW);
    delay(1000);
  }
  
  // Publish data
  if (! distance.publish((int)distance_data))
  Serial.println("Failed to publish temperature");
  else
  Serial.println("Distance published!");
  
  //Delay 50ms before next reading.
  delay(5000);
}

void connect() {
Serial.print("Connecting to Adafruit IO... ");
int8_t ret;
while ((ret = mqtt.connect()) != 0) {
  switch (ret) {
    case 1: Serial.println("Wrong protocol"); break;
    case 2: Serial.println("ID rejected"); break;
    case 3: Serial.println("Server unavail"); break;
    case 4: Serial.println("Bad user/pass"); break;
    case 5: Serial.println("Not authed"); break;
    case 6: Serial.println("Failed to subscribe"); break;
    default: Serial.println("Connection failed"); break;
  }
  if (ret >= 0) {
    mqtt.disconnect();
  }
  Serial.println("Retrying connection...");
  delay(5000);
}
Serial.println("Adafruit IO Connected!");
}
